<%-- Copyright (c) 2003-2009 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --%>
<%@include file="/shell/default.jspf"%>
<%@ taglib prefix="cpb" uri="http://www.sas.com/cpb/tag" %>
<%@ taglib prefix="sas" uri="http://www.sas.com/taglib/sas" %>
<%@ taglib prefix="c"   uri="http://java.sun.com/jsp/jstl/core" %>

<%@page import="com.sas.solutions.casemgmt.web.party.*"%>
<%@ page import="com.sas.fsd.shared.util.StringUtil" %>
<%@ page import="com.sas.solutions.cpb.web.util.CPBUtil" %>

<fmt:message bundle="${appResources}" var="partyCommentsSection" key="section.comments.list.header.txt" />
<fmt:message bundle="${appResources}" var="partyAttachmentsSection" key="section.attachments.list.header.txt" />

<%
PartyActionModel partyModel = PartyActionModel.getFromRequest(request);
String pageTitle = CPBUtil.getPageTitle(request) == null ? "" : CPBUtil.getPageTitle(request);
%>

<script type="text/javascript">
Party.FORM_NAME = "<%=StringUtil.escapeJSForHTML(partyModel.getFormName())%>";
Party.OBJECT_TYPE = "<%=partyModel.getObjectTypeId()%>";
Party.KEY = "<%=partyModel.getEntityKey()%>";
Party.ID = "<%=StringUtil.escapeJSForHTML(partyModel.getEntity().getId())%>";
Party.EDITABLE = <%=partyModel.isPageEditable()%>;

var sas = {
      requires: function() {
         // stub out, last use of tbeans
      }
};
</script>

<table width="100%">
   <tr>
      <td>
         <h2><%=pageTitle%></h2>
         <div class="leftpadding">
            <% partyModel.writeScreen(pageContext, out); %>
         </div>
      </td>
   </tr>
</table>
<br />
<table width="100%">
   <tr>
      <td>
         <h3>${partyAttachmentsSection}: <%=pageTitle%></h3>
         <div class="leftpadding">
            <% partyModel.writeAttachmentsForPrint(pageContext); %>
         </div>
      </td>
   </tr>
</table>
<script>
   var loaded = {
         page: false,
         stores: false,
         ready: function() {
            return this.page && this.stores;
         }
   };
   
   require(['sas-ecm/case/CasePrint'], function(CasePrint) {
      CasePrint.registerPageListener('party_' + Party.KEY, function(id) {
         loaded.stores = true;
         if(loaded.ready()) {
            window.top.loadFrameToDiv(printID);
         }
      });
   });
   
   function frameLoaded() {
      loaded.page = true;
      if(loaded.ready()) {
         window.top.loadFrameToDiv(printID);
      }
   }
</script>
